// pnPlugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "resource.h"
#include "pnPlugin.h"
#include "cv.h"
#include "myRGB2HSV.h"

static int selectedMode = 0;
static int oldMode = 0;

void appliquerLut (IplImage* im, char lut[]);

plInfo Info = 
	{"0.4.0",
	"effet",
	"posterisation",
	"rduction du nombre de couleurs"
	};


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT message,WPARAM wParam,LPARAM lParam)
{
	int radioSel;
	switch (message)
	{
	case WM_INITDIALOG :
		oldMode = selectedMode;
		switch (selectedMode) {
		case 0:
			radioSel = IDC_RADIO1;
			break;
		case 1:
			radioSel = IDC_RADIO2;
			break;
		case 2:
			radioSel = IDC_RADIO3;
			break;
		default:
			radioSel = IDC_RADIO1;
			break;
		}
		CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, radioSel);
		return true;

	case WM_COMMAND:
		switch (LOWORD (wParam))
			{
			case IDC_RADIO1:
				selectedMode = 0;
			break;
			case IDC_RADIO2:
				selectedMode = 1;
			break;
			case IDC_RADIO3:
				selectedMode = 2;
			break;
			case IDCANCEL:
				selectedMode = oldMode;
			case IDOK:
				EndDialog(hDlg,0);
				return true;
			}
			break;

		}
		return FALSE;
}

			   
// application de la LUT
void appliquerLut (IplImage* im, unsigned char lut[])
{
char bval;

Ipp8u * pI = (unsigned char *) im->imageData;
int nBytes = im->imageSize;
unsigned char *pLut = &lut[0];
for (int x = 0; x < nBytes; x++)      
        {
         bval= pLut[*pI];
		 *pI=bval;
         pI++;
        }
}

PNPLUGIN_API const char* PnPluginAppName( void )
{
    //version;
    const char * appName;
    appName = "PortaNum";
    return appName;
}

PNPLUGIN_API int PnPluginInfo(plInfo * pInfo )
{
	*pInfo = Info;
    return 1;
}

PNPLUGIN_API IppStatus PnPluginDialog(HINSTANCE hInstance, HWND hwnd)
{	char buffer[128];
	LPSTR lpstrPrompt = &buffer[0];
	int res = DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),hwnd, AboutDlgProc);
	if (res == -1 ) { 
		MessageBox(NULL,lpstrPrompt,"",NULL);
		return 1; // pas de page de config
	}
	return 0; // ok
}

PNPLUGIN_API IppStatus PnPluginFunction( Ipp8u* pSrc, int srcStep, Ipp8u* pDst, int dstStep, IppiSize roiSize, int mode, int coef )
{
    IppStatus status = 0;  // 0 = no error
	Ipp8u * pS = pSrc;
	Ipp8u * pD = pDst;

// calcul de la loi de quantification

int val=0;
int i;
Byte lut[256];

int cc =  coef; // *0.5
if (cc == 0) cc = 1;
int cc2 = cc/2;
int minLut = 0;
int maxLut = 255;
 for (i=0;i<256;i++)
        {
		if (i<cc2) lut[i] = minLut;
		else {
        val= ((int)((i + cc2)/ cc )) *cc ;
        lut[i]=CV_CAST_8U(val);
			}
		}

 // mthode filtre

	IplImage* im1 = NULL;
	IplImage* im2 = NULL;
	IplImage* im3 = NULL;
	IplImage* im4 = NULL;

	CvSize imSize;
	imSize.width = roiSize.width;
	imSize.height = roiSize.height;

	im1 = cvCreateImage( imSize, IPL_DEPTH_8U, 3 );	 // image d'origine
	im2 = cvCreateImage( imSize, IPL_DEPTH_8U, 1 );	 // 
	im3 = cvCreateImage( imSize, IPL_DEPTH_8U, 3 );	 // 
	im4 = cvCreateImage( imSize, IPL_DEPTH_8U, 3 );	 // image de destination


	CopyMemory( im1->imageData, pSrc, srcStep * roiSize.height );
	// conversion RGB->HSV
	RGB2HSV( im1,im3 );
	
	// traiter les canaux HS
	// canal H
	cvSplit(im3,im2,NULL,NULL,NULL);
	switch (selectedMode) {
		case 0:
			cvSmooth(im2,im2, CV_GAUSSIAN, 3,3,0);
		break;
		case 1:
			cvSmooth(im2,im2, CV_GAUSSIAN, 7,7,0);
		break;
		default:
			break;
	}
	// appliquerLut(im2,lut);
	cvCvtPlaneToPix(im2,NULL,NULL,NULL,im3 );	
	// canal S
	cvSplit(im3,NULL,im2,NULL,NULL);
	switch (selectedMode) {
		case 0:
			cvSmooth(im2,im2, CV_GAUSSIAN, 3,3,0);
		break;
		case 1:
			cvSmooth(im2,im2, CV_GAUSSIAN, 7,7,0);
		break;
		default:
			break;
	}
	appliquerLut(im2,lut);
	cvCvtPlaneToPix(NULL,im2,NULL,NULL,im3 );

	// canal V
	cvSplit(im3,NULL,NULL,im2,NULL);
	appliquerLut(im2,lut);
	cvCvtPlaneToPix(NULL,NULL,im2,NULL,im3 );
	HSV2RGB( im3,im4 );
	
	CopyMemory( pDst, im4->imageData, srcStep * roiSize.height );

    cvReleaseImage( &im1 );
    cvReleaseImage( &im2 );
	cvReleaseImage( &im3 );
    cvReleaseImage( &im4 );  

    return status;
}

